#include<netinet/in.h>
#include<time.h>
#include<sys/types.h>
#include<stdio.h>
#include<errno.h>
/*#include"cgi.c"*/
/*#include"wh.h"*/
const int MAXLINE = 4096 ;
int SERV_PORT = 8081;
char buff[4096] ;
char clireq[4096] ;
char serres[4096] ;
int LISTENQ = 1024 ; /*multiple request */
ssize_t n ;

char *filename ;
char *rootpath ;
char *dirpath ;
FILE *fp ;
int listenfd, connfd ;
time_t ticks ;
char *req ;
char *req1 ;
char *res ;
pid_t childpid ;
socklen_t clilen ;
struct sockaddr_in cliaddr, servaddr ;

void response(int) ;
void request(int) ;
void parse_url() ;
void getfile() ;
void getdir() ;

/*extern void sendcgi(Request*);*/
int i = 0 ;
int count = 0 ;

int main(int argc, char **argv)
{

	listenfd = socket(AF_INET, SOCK_STREAM, 0) ;/*creation o fsockets*/

	if(listenfd < 0)
		printf("Error in starting server") ;

	bzero(&servaddr, sizeof(servaddr)) ;

	servaddr.sin_family = AF_INET ;
	servaddr.sin_addr.s_addr = htonl(INADDR_ANY) ;
	servaddr.sin_port = htons(SERV_PORT) ;

	bind(listenfd, (struct sockaddr_in *) &servaddr, sizeof(servaddr)) ;

	listen(listenfd, LISTENQ) ;
	printf("server has started at port 8080 waiting for a request\n");
	for(; ;)/*starting a daemon,that runs always*/
	{
	    clilen = sizeof(cliaddr) ;
	    connfd = accept(listenfd, (struct sockaddr_in *) &cliaddr, &clilen) ;

	    if(connfd < 0)
		printf ("\nError in Connecting to client") ;

	    if((childpid = fork()) == 0)  /*forking a child*/
	    {/*connfd=client side socket*/
		close(listenfd) ;
		request(connfd) ;
		response(connfd) ;/*parent process continuously listens for request in the for loop,as soon as a request arrives ,it creates a child process*/
		close(connfd) ;
		exit(0) ;
	        printf("\tConnection closed ") ;
	    }
	}
}
void request(int sockfd)
{
	int n = 0 ;
	readline(sockfd, clireq, MAXLINE);
	printf("\nClient Request : %s", clireq) ;

	req = (char *) malloc(strlen(clireq)) ;
	req1 = (char *) malloc(strlen(clireq)) ;/*modified request*/
	dirpath = (char *) malloc(strlen(clireq)) ;
	filename = (char *) malloc(strlen(clireq)) ;

	strcpy(req, clireq) ;
	strcpy(req1, clireq) ;
	strcpy(dirpath, clireq) ;
	strcpy(filename, clireq) ;

	printf("\nREQ : %s", req) ;
	parse_url() ;
	printf("\nREQ1 : %s", req1) ;
	getdir() ;
	printf("\nDirectory : %s", dirpath) ;
	getfile() ;
	printf("\nFilename  : %s", filename) ;
}
void response(int sockfd)
{
	char sendline[MAXLINE] ;
	int ri = 0 ;
	res = (char *) malloc(strlen(req1)) ;
	if(res == NULL)
		printf("Sorry unable to allocate memory") ;
//	strcpy(res, req1) ;
//	printf("\nResponse copied: %s", res) ;
	res[0] = '\0' ;
	printf("\nDirectory : %s", dirpath) ;
	printf("\nFilename  : %s", filename) ;
	strcat(res, dirpath) ;
	printf("\nRDirectory : %s", res) ;
	strcat(res, filename) ;
		ri = strlen(res) ;
	res[ri - 1] = '\0' ;
	printf("\nRFile : %s", res) ;

	printf("\nReady to print the contents of file ") ;
	fflush(stdout) ;
	if(iscgi() == -1)
	{
		//sendcgi( ip);

	}
	else
	{
		fp = fopen(res, "r") ;
		while(!feof(fp))
		{
			fgets(sendline, sizeof(sendline), fp) ;/*storing maxline amount of contents*/
			printf("%s", sendline) ;		
			write(sockfd, sendline, strlen(sendline)) ;
		}
	fflush(stdout) ;
	close(fp) ;
	}
}

readn(int fd, char *ptr)/*reading n no. of bytes*/
{
	static int read_cnt = 0 ;/*reading half a line*/
	static char *read_ptr ;
	static char read_buf[4096] ;
	
	if(read_cnt <= 0)
	{
again:
	if((read_cnt = read(fd, read_buf, sizeof(read_buf))) < 0)
	{
		if(errno == EINTR)/*error presence*/
			goto again ;
		return (-1) ;
	}
	else if(read_cnt == 0)
		return (0) ;
	read_ptr = read_buf ;
	}
	read_cnt-- ;
	*ptr = *read_ptr++ ;/*manipulated by readn and then sent to readline*/
	return (1) ;	
}

readline(int ff, void *vptr, size_t maxlen)
{
	int n, rc ;
	char c, *ptr ;

	ptr = vptr ;/*client request*/
	for(n = 1; n < maxlen; n++)
	{
		if((rc = readn(ff, &c)) == 1)/*if something read*/
		{
			*ptr++ = c ;
			if(c == '\n')
				break ;
		}
		else if(rc == 0)
		{
			if(n == 1)
				return (0) ;
			else
				break ;
		}
		else
		{
			return (-1) ;/*error*/
		}
	}
	*ptr = 0 ;
	return (n) ;
}

writen(int fd, const void *vptr, size_t n)
{
	size_t nleft ;
	ssize_t nwritten ;
	const char *ptr ;
	ptr = vptr ;
	nleft = n ;/*bytes still left to write*/
	while(nleft > 0)
	{
		if((nwritten = write(fd, ptr, nleft)) <= 0)
		{
			if(errno == EINTR)
				nwritten = 0 ;
			else
				return (-1) ;
		}
		nleft -= nwritten ;
		ptr += nwritten ;
	}
	return (n) ;
}

void parse_url()
{
	int l1 = 0 ;
	int i = 0 ;
	int j = 0 ;
	int w = 0 ;
	l1 = strlen(req) ;
	for(i = 4; i <= l1; i++)/*removinf get and space*/
	{	
		if(req[i] == ' ') 
			break ;		
	}
	for(w = 0, j = 4; j <= i; j++, w++)
	{
	    req1[w] = req[j] ;
	}
	req1[w] = '\0' ;
}
void getfile()
{
	int l1 = 0 ;
	int i = 0 ;
	int j = 0 ;
	int w = 0 ;
	l1 = strlen(req1) ;
	for(i = l1; i >= 0; --i)
	{	
		if(req1[i] == '/') /*tracinfg from behind*/
			break ;		
	}
	
	for(w = 0, j = i ; j <= l1 ; j++, w++)
	{
		filename[w] = req1[j] ;
	}
//filename[w] = '\0' ;
}
void getdir()
{
	int l1 = 0 ;
	int i = 0 ;
	int j = 0 ;
	l1 = strlen(req1) ;
	for(i = l1; i >= 0; --i)
	{	
		if(req1[i] == '/') 
			break ;		
	}
	for(j = 0 ; j < i ; j++)
	{
		dirpath[j] = req1[j] ;
	}
	dirpath[j] = '\0' ;
}

int iscgi()
{
	int i = 0 ;
	int len = strlen(filename) ;
	for(i = 0; i < len; i++)
	{
		if(filename[i] == '.')
		{
			if(filename[i + 1] == 'c')
			{
				if(filename[i + 2] == 'g')
				{
					if(filename[i + 3] == 'i')
					{
						return 1 ;
					}
				}
			}
		}
	}
	return -1 ;	
}

